\titre;PicT870  16F870  clignote  par interruption
\b;RA0..5  RB0..7 RC0..7  priode 512 ms

.Proc	16f870
.Ref	16F870

TPhase	= 100	; 200 us
IniOption	= 2'00000000	; :2  2us
IniIntCon	= 2'10100000	; GIE and TOIE on

Motif	= 16'F0

.Loc	16'20
C1:	.16	1
C2:	.16	1
Temp:	.16	1
SaveF:	.16	1	; Interruptions
SaveW:	.16	1

.Loc	0

Deb:
	Jump	Main

.Loc	4	; Interrupts
Set	PortC:#0
	Move	W,SaveW	; Ne modifie pas F
	Swap	F,W	; A cause du retour
	Move	W,SaveF

	Clr	Intcon:#TOIF
	Move	#256-TPhase+6,W
	Move	W,TMR0

; Attente
	DecSkip,EQ	C1
	Jump	A$
	DecSkip,EQ  C2
	Jump	A$
	Move	#10,W
	Move	W,C2
	Not	Temp
	Move	Temp,W
;	Move	W,PortA
	Move	W,PortB
	Move	W,PortC
  A$:
	Swap	SaveF,W  	; Un Move modifierait F!!
	Move	W,F	 	;  artefact du PIC
	Swap	SaveW	 	;  se souvenir du truc
	Swap	SaveW,W  	; Un Move modifierait F!!
Clr	PortC:#0
	RetI

Main:	Clr	PortA
	Set	Status:#RP0
	Move	#16'06,W
	Move	W,AdCon1
 	Move	#0,W		; sorties
	Move	W,PortA
	Move	W,PortB
	Move	W,PortC
	Clr	Status:#RP0

	Move	#IniOption,W
	Move	W,Option
	Move	#256-TPhase+6,W
	Move	W,TMR0

	Move	#IniIntCon,W	; GIE and TOIE on
	Move	W,IntCon

	Move	#Motif,W
	Move	W,Temp

Loop:
	Nop
	Nop
Inc	PortA
	Nop
	Jump	Loop

.Align	16'8
.16	"P","i","c","t","8","7","0","i"
;.Fill.16 	FinProg+1-APC,-1
;.Loc	16'2007
;.16	16'3F39	; Config
.End
