\titre;PicT870d  16F870  clignote  registre  dcalage
\b;RA0..5  RB0..7 RC0..7  priode 0.65 s

.Proc	16f870
.Ref	16F870

Valeur	= 16'55

C1	= 16'20
C2	= 16'21
Data	= 16'22
Motif	= 16'23

;PortB
bD	= 7
bCk	= 6
.Loc	0

Deb:
	Clr	PortA
	Set	Status:#RP0
	Move	#16'06,W
	Move	W,AdCon1
 	Move	#0,W		; sorties
	Move	W,PortA
	Move	W,PortB
	Move	W,PortC
	Clr	Status:#RP0

	Move	#Valeur,W
	Move	W,Motif
Loop:
	Not	Motif
	Move	Motif,W

	Call	SndS8
; Attente
  A$:	DecSkip,EQ	C1
	Jump	A$
	DecSkip,EQ	C2
	Jump	A$
	
	Jump	Loop

\macros;Registre  dcalage srie|
\b;Les transferts durent 60 us et ne doivent tre espacs
\b;de 1  10 ms au moins.
.Macro	SetD
	Set	PortB:#bD
	Nop
.EndMacro
.Macro	ClrD
	Clr	PortB:#bD
	Nop
.EndMacro

.Macro	SetCk
	Set	PortB:#bCk
.EndMacro
.Macro	ClrCk
	Clr	PortB:#bCk
.EndMacro
.Macro	FullCk	; Ck  .../'''\...
	SetCk
	Nop		; 1 \mu;s pulse min
	ClrCk
.EndMacro

\rout;SndS8|Envoie et lit 8 bits, sans Start/Stop
; Dure 85 microsecondes
\in;W  (data in)
\out;W = DataOut
\mod;W SCnt  DataOut
; CK  ________/'\\__/'\\__/'\\_... _/'\\_____
; Dout XXXXX\\_===\\_===\\_=== ... \\========
SndS8:
	Move	W,Data
	Move	#8,W
	Move	W,C1
  L$:
	ClrD
	RLC	Data
	Skip,CC
	SetD
	FullCk
	DecSkip,EQ C1
	Jump	L$
	Ret

.Align	16'8
.16	"P","i","c","t","8","7","0","d"
;.Fill.16 	FinProg+1-APC,-1
;.Loc	16'2007
;.16	16'3F39	; Config
.End

